#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<algorithm>
#include<string.h>
#include<math.h>
#include<queue>
#include<vector>
#include<stack>
#include<set>
#include<ctime>
using namespace std;

#define FOR(i,n)  for(i=0;i<n;i++)

#define pi(n)   printf("%d\n",n);

#define ps(c)   printf("%s\n",c);

#define si(n)   scanf("%d",&n);

#define ss(n)   scanf("%s",n);

#define sf(n)   scanf("%lf",&n);

#define sc(n)   scanf(" %c",&n);

#define inf 1000007

#define pb(a)	push_back(a)

#define FORi(i,a,n) for(i=a;i<n;i++)

#define mat 2400000

#define Total_Training_Documents_Final 2365426

#define Total_Test_Documents 10

#define Total_Validation_Documents 10

//#define value_k 5
int parameter_total_final_labels;
double threshold[10] ;
 
double prev_threshold ;
class label
{
public:
	int LabelNum;
	int LabelCount;
	void ini(int a,int b)
	{
		LabelNum=a;
		LabelCount=b;
	}
};

class Score
{
public:
	int index;
	double value;
	void ini(int a, double b)
	{
		index=a;
		value=b;
	}

};

class duo
{
public:
	int Present_Features;
	int Present_Features_Number;
	void ini(int a,int b)
	{
		Present_Features_Number=b;
		Present_Features=a;
	}
};
class Document
{
public:
	std::vector<int> Present_Labels;
//	std::vector<int> Present_Features;
//	std::vector<int> Present_Features_Number;
	std::vector<duo> Features;
	void ini()
	{
		Present_Labels.clear();
	//	Present_Features.clear();
	//	Present_Features_Number.clear();
		Features.clear();
	}
};
Document *Training_Set;
double total_sum_lengths;
int *Number_Documents;
std::vector<int> *FeatureAssociatedDocument;
std::vector<int> *LabelAssociatedDocument;
short int *IsDocumentValidation;
std::vector<int> ValidationSet;
//std::vector<int> DocumentSetS;
std::vector<Score> FinalDocumentSet;
Score *SimilarityScoreBetweenDocuments;
int *LabelFrequency;
int *OverallFrequencyOfDocument;
std::vector<Score> AllPossibleLabels;
std::vector<Score> DocumentSetS;
std::vector<int> UltimateFinalLabel;
void swap1(double *a,double *b)
{
	double t;
	t=*a;
	*a=*b;
	*b=t;
}

void swap2(int *a,int *b)
{
	int t;
	t=*a;
	*a=*b;
	*b=t;
}

bool comp(duo a,duo b)
{
	return a.Present_Features<b.Present_Features;
}

void GetDocument(int final_number, bool isValidation)
{
	int i,j,k,nu;
	OverallFrequencyOfDocument[final_number]=0;
	//Document temp;
	//temp.ini();
	//Training_Set.push_back(temp);
	duo temp;
	char ch;
	si(nu)
	scanf("%c",&ch);
	i=0;
	Training_Set[final_number].ini();
	while(ch==',')
	{
		Training_Set[final_number].Present_Labels.push_back(nu);
		if(!isValidation)
		{	LabelAssociatedDocument[nu].push_back(final_number);
			LabelFrequency[nu]++;
		}
//		Number_Documents[nu]++;
		si(nu)
		scanf("%c",&ch);
	}
	Training_Set[final_number].Present_Labels.push_back(nu);
	if(!isValidation)
	{
			LabelAssociatedDocument[nu].push_back(final_number);
			LabelFrequency[nu]++;
	}
	j=0;
	si(nu);
	scanf("%c",&ch);
	while(ch==':')
	{
		si(k)
		temp.ini(nu,k);
		if(!isValidation)
	{
		total_sum_lengths+=k;
		OverallFrequencyOfDocument[final_number]+=k;
		Number_Documents[nu]++;
		FeatureAssociatedDocument[nu].push_back(final_number);
	//	Training_Set[final_number].Present_Features.push_back(nu);
	//	Training_Set[final_number].Present_Features_Number.push_back(k);
	
	}
		Training_Set[final_number].Features.push_back(temp);
		scanf("%c",&ch);
		if(ch=='\n')
			break;
		else
		{
			si(nu)
			scanf("%c",&ch);
	//		if(final_number==0)
	//		printf("%c",ch);
		}
	}
	sort(Training_Set[final_number].Features.begin(),Training_Set[final_number].Features.end(),comp);
//	printf("New document read\n");
}

void GetTestDocument(int final_number)
{
	int i,j,k;
	int nu;
	duo temp;
	char ch;
	si(nu)
	Training_Set[final_number].ini();
	while(nu>0)
	{	
		si(k)
		temp.ini(nu,k);
	
		Training_Set[final_number].Features.push_back(temp);
		si(nu)
		
	//		if(final_number==0)
	//		printf("%c",ch);
		
	}
	sort(Training_Set[final_number].Features.begin(),Training_Set[final_number].Features.end(),comp);
//	printf("New document read\n");
}

int GetTrainingSet(int Total_Training_Documents)
{
	char ch;
	int i=0;
	int j;
	FOR(i,Total_Training_Documents)
	{
//		ungetc(ch,stdin);

		if(i >= Total_Training_Documents_Final)
			GetDocument(i,1);
		else
			GetDocument(i,0);
	/*	if(i<=2)
		{
			printf("Major labels are");
			FOR(j,Training_Set[i].Present_Labels.size())
			{
				printf("%d, ",Training_Set[i].Present_Labels[j]);
			}
			ps("")
			printf("Top features of 1st training set are ");
			FOR(j,Training_Set[i].Features.size())
			{
				printf("%d, ",Training_Set[i].Features[j].Present_Features);
			}
			ps("\n")
		}
	*/	
	}
	return i;
}
//returns index of the feature if feature feature_number is present in document document_number
int search_new(int document_number, int feature_number)
{
	int st,en,mid;
	st=0;
	en=Training_Set[document_number].Features.size()-1;
	while(st<=en)
	{
		mid=(st+en)/2;
		if(Training_Set[document_number].Features[mid].Present_Features==feature_number)
		{
			return mid;
		}
		else if(Training_Set[document_number].Features[mid].Present_Features<feature_number)
		{
			st=mid+1;
		}
		else
		{
			en=mid-1;
		}
	}
	return -1;
}

bool sort_value(Score a, Score b)
{
	if(a.value!=b.value)
		return (a.value<b.value);
	else
		return (a.index<b.index);
}

void GetFinalDocumentSet(int final_number,int value_k,double k1_param,double b_param,double s_param,double average_length_document)
{
	int i,j,k,Number_Documents_GivenFeature;
	double freq1,freq2,idf,index_in_training;
	//double average_length_document;
/*
	FOR(i,Total_Training_Documents)
		SimilarityScoreBetweenDocuments[i].ini(i,0);
*/
	//cout << "The # of features in test document : " << Training_Set[final_number].Features.size() << endl;
	Score temp2;
	FOR(i,DocumentSetS.size())
	{
		FOR(j,Training_Set[final_number].Features.size())
		{
			Number_Documents_GivenFeature=Number_Documents[Training_Set[final_number].Features[j].Present_Features];
			idf=log10((double)(Total_Training_Documents_Final - Number_Documents_GivenFeature + 0.5)/(double)(Number_Documents_GivenFeature + 0.5));
			freq1=(double)((k1_param+1)*(Training_Set[final_number].Features[j].Present_Features_Number))/(k1_param+1+((b_param*s_param)/average_length_document)-b_param);
			index_in_training=search_new(DocumentSetS[i].index,Training_Set[final_number].Features[j].Present_Features);
			if(index_in_training==-1)
				continue;
			freq2=(double)((k1_param+1)*(Training_Set[DocumentSetS[i].index].Features[index_in_training].Present_Features_Number))/(k1_param+1+((b_param*s_param)/average_length_document)-b_param);
			DocumentSetS[i].value+=(freq2*freq1*idf);
		}
	}
	sort(DocumentSetS.begin(),DocumentSetS.end(),sort_value);
	int size_s = DocumentSetS.size();
	for(i=size_s-1;(i>=size_s - value_k) && (i >= 0);i--)
	{
		FinalDocumentSet.push_back(DocumentSetS[i]);
	}

}


std::vector<int> FindTop3(int final_number)
{
	int i,j,k;
	int num[3];
	double tfidf[3]={0,0,0};
	double temp_tf,temp_idf,temp_tfidf;/*
	printf("The top features of the test document are");
	FOR(i,Training_Set[final_number].Features.size())
	{
		printf("%d, ",Training_Set[final_number].Features[i].Present_Features);
	}
	ps("")
	*/
	int count = 0;
	FOR(i,Training_Set[final_number].Features.size())
	{
	//	temp_tf=0.5+(0.5*((double)Training_Set[final_number].Features[i].Present_Features_Number)/(double)max_frequency_feature);
		temp_tf=(double)Training_Set[final_number].Features[i].Present_Features_Number;
		temp_idf=log10((double)(Total_Training_Documents_Final)/(double)Number_Documents[Training_Set[final_number].Features[i].Present_Features]);
		temp_tfidf=temp_tf*temp_idf;
		if(temp_tfidf>=tfidf[2])
		{
			tfidf[2]=temp_tfidf;
			num[2]=Training_Set[final_number].Features[i].Present_Features;
			count ++;
		}
		if(tfidf[2]>tfidf[1])
		{
			swap1(&tfidf[2],&tfidf[1]);
			swap2(&num[2],&num[1]);
		}
		if(tfidf[1]>tfidf[0])
		{
			swap1(&tfidf[1],&tfidf[0]);
			swap2(&num[1],&num[0]);
		}
	}
	std::vector<int> final;
	final.clear();
	count = count < 3 ? count : 3;
	FOR(i,count)
	{
		final.push_back(num[i]);
	}
	/*
	printf("The top3 features for the test document are");
	FOR(i,3)
	{
		printf("%d, ",final[i]);
	}
	ps("")
	*/
	return final;
}


double GetSimilarity(std::vector<int> UltimateFinalLabel,int DocumentNumber)
{
	int i,j,k;
	double nu1,nu2,final_value=0;
	nu1=1.0/sqrt((double)UltimateFinalLabel.size());
	nu2=1.0/sqrt((double)Training_Set[DocumentNumber].Present_Labels.size());
	FOR(i,UltimateFinalLabel.size())
	{
		FOR(j,Training_Set[DocumentNumber].Present_Labels.size())
		{
			if(UltimateFinalLabel[i]==Training_Set[DocumentNumber].Present_Labels[j])
			{
				final_value+=(nu1*nu2);
			}
		}
	}
	return final_value;
}

int main()
{
	//Major parameters defined here.

	double k1_param=6,b_param=0.75,s_param,alpha_parameter=0.75;
	int value_k=50;

parameter_total_final_labels=3;

threshold[1] = 1; 
threshold[2] = 0.6;
threshold[3] = 0.4;
//prev_threshold = 1;

	//Major parameters end here.

	label temp_label;
	int total_documents;
	double average_length_document;
	int z;
	clock_t start_input, end_input, start_prep, end_prep, start_test, end_test;
	start_prep=clock();
	int max_frequency_feature=0;
	std::vector<int> Top3Features;
	Number_Documents=new int[mat+1];
	IsDocumentValidation=new short int[mat+1];
	FeatureAssociatedDocument=new std::vector<int>[mat+1];
	LabelAssociatedDocument=new std::vector<int> [mat+1];
	LabelFrequency=new int[mat+1];
	Training_Set=new Document[mat+1];
	OverallFrequencyOfDocument=new int[mat+1];
//	SimilarityScoreBetweenDocuments=new Score[mat+1];
	int i,j,k;
	FOR(i,mat+1)
	{
		LabelAssociatedDocument[i].clear();
		LabelFrequency[i]=0;
		Number_Documents[i]=0;
		FeatureAssociatedDocument[i].clear();
		IsDocumentValidation[i]=0;
	}
	total_sum_lengths=0;
	start_input=clock();
	total_documents=GetTrainingSet(Total_Training_Documents_Final + Total_Validation_Documents);
	
	end_prep=clock();
	start_test=clock();
	//total_sum_lengths contains the total number of features in all of the training documents
	average_length_document=total_sum_lengths/(double)Total_Training_Documents_Final;
	s_param=average_length_document;
/*	FOR(i,2300000)
	{
		if(LabelAssociatedDocument[i].size()!=0)
		{
			FOR(j,LabelAssociatedDocument[i].size())
			{
				if(IsDocumentValidation[LabelAssociatedDocument[i][j]]==1)
					break;
			}
			if(j<LabelAssociatedDocument[i].size())
			{
				continue;
			}
			else
			{
				IsDocumentValidation[LabelAssociatedDocument[i][0]]=1;
			}
		}
	}

	ValidationSet.clear();
	FOR(i,Total_Training_Documents_Final)
	{
		if(IsDocumentValidation[i]==1)
			ValidationSet.push_back(i);
	}
	*/
//	cout << "Size of the validation set is : " << ValidationSet.size() << endl;
	//Validation Set of size ~200000
	
	int test_cases;
	//test_cases = Total_Test_Documents;
	//test_cases = ValidationSet.size();
	double max_avg_similarity = 0;
	test_cases = 10000;
	int best_k = 0;
	double best_alpha = 0;
	double present_threshold;
//for(parameter_total_final_labels = 2;parameter_total_final_labels<=5;parameter_total_final_labels++)
//{	
//for(present_threshold = prev_threshold;present_threshold >= 0.4;present_threshold-=0.1)
//for(value_k = 10;value_k <= 60 ; value_k+=10)	
//{	
	//threshold[parameter_total_final_labels]= present_threshold;
	double timer = 0;
	double final_similarity = 0;
	double avg_similarity =0;
	FOR(z,test_cases)
	{
		start_test=clock();
		int test_doc_index;
		test_doc_index = Total_Training_Documents_Final + z;
		//test_doc_index= mat ; // if testing 
  		
		//Training_Set[test_doc_index].ini();   // only if testing
		//GetTestDocument(test_doc_index);   //if testing
		
		//GetDocumentSetS part begins here. It is used for pruning the 2mil documents to a reasonable number.
		Top3Features=FindTop3(test_doc_index);
		std::set<int>Myset;
		int temp_value,new_temp;
		FOR(i,Top3Features.size())
		{
			
			temp_value=Top3Features[i];
			FOR(j,FeatureAssociatedDocument[temp_value].size())
			{
				Myset.insert(FeatureAssociatedDocument[temp_value][j]);
			}
		}
		Score temp3;
		DocumentSetS.clear();




		while(!Myset.empty())
		{
			new_temp=*Myset.begin();
			temp3.ini(new_temp,0);
			DocumentSetS.push_back(temp3);
			Myset.erase(Myset.begin());
		}


		
				




		//GetDocumentSetS part ends here.
	//		cout << "Size of the set S is : " << DocumentSetS.size() << endl;
		FinalDocumentSet.clear();
		
		GetFinalDocumentSet(test_doc_index,value_k,k1_param,b_param,s_param,average_length_document);
				
	// FinalDocumentSet is set S

	//	cout << " Time taken for GETFINAL DOC SET S : " << (double)(end_test - start_test)/ (CLOCKS_PER_SEC) << endl;
		AllPossibleLabels.clear();

		//In this part, the voting for the various classes is done. 	
		//BM25 is used again in this part.
		//Taking value of alpha=0.5, I have written this code. I am not sure what the values of alpha should be.
		//The values of alpha will need to be finetuned.

		FOR(i,FinalDocumentSet.size())
		{
			temp_value=FinalDocumentSet[i].index;
			FOR(j,Training_Set[temp_value].Present_Labels.size())
			{
				Myset.insert(Training_Set[temp_value].Present_Labels[j]);
			}
		}
		while(!Myset.empty())
		{
			new_temp=*Myset.begin();
			temp3.ini(new_temp,0);
			AllPossibleLabels.push_back(temp3);
			Myset.erase(Myset.begin());
		}

		// All possiblelabels has the set of unique labels on which voting needs to be done to decide the labels for the test document

		int index_in_training,flag;
		double bm25,freq2,freq1,idf;
	//	cout << "FinalDocument Set Size : " << FinalDocumentSet.size() << endl;
	//	cout << "All possible labels  Size : " << FinalDocumentSet.size() << endl;
		
		
		FOR(i,FinalDocumentSet.size())
		{	// two loops ---- time ??
			FOR(j,AllPossibleLabels.size())
			{
				flag=0;
				new_temp=FinalDocumentSet[i].index;
				FOR(k,Training_Set[new_temp].Present_Labels.size())
				{
					if(Training_Set[new_temp].Present_Labels[k]==AllPossibleLabels[j].index)
					{
						flag=1;
						break;
					}
				}
				if(flag==1)
				{
					AllPossibleLabels[j].value+=pow(FinalDocumentSet[i].value,alpha_parameter);
				}
			}
		}
		sort(AllPossibleLabels.begin(),AllPossibleLabels.end(),sort_value);
	
		

	//	cout << " Time taken for label filtering : " << (double)(end_test - start_test)/ (CLOCKS_PER_SEC) << endl;
		UltimateFinalLabel.clear();

		//In the final label prediction, we are using a top-k labels procedure. 
		//The original paper uses a tuning scheme and benchmarks for each of the (unknown) r labels.
		//and predicts a label only if its score is greater than the benchmark.
		//A parameter total_final_labels is used here.
		int kh = 1;
		for(i=AllPossibleLabels.size()-1;(i>=0)&&(i>=AllPossibleLabels.size()-parameter_total_final_labels);i--)
		{	
			if(AllPossibleLabels[i].value/(AllPossibleLabels[AllPossibleLabels.size()-1].value) >= threshold[kh])
			{	UltimateFinalLabel.push_back(AllPossibleLabels[i].index);
				kh++;
			}
			else
				break;
		}
/*
		FOR(i,UltimateFinalLabel.size())
		{
			printf("%d, ",UltimateFinalLabel[i]);
		}
		ps("")
*/
		final_similarity = GetSimilarity(UltimateFinalLabel,test_doc_index);
		avg_similarity += final_similarity;		
		end_test = clock();
		timer += end_test - start_test;
	}
		if(avg_similarity > max_avg_similarity)
		{	
			max_avg_similarity = avg_similarity;
			//best_k = value_k;
			//best_alpha = alpha_parameter;
			//prev_threshold = present_threshold;
		}	
		cout << " Time taken : " << (double)(timer)/ (CLOCKS_PER_SEC) / Total_Validation_Documents<< endl;
		//cout << "The avg_similarity for threshold "<< present_threshold<< " is : " << avg_similarity/test_cases<< endl;		
//}
	
	cout<< "The _similarity for predictions  is " << max_avg_similarity/Total_Validation_Documents<< endl;
	
	
	return 0;
}
